<?php
define('THEME_URL', get_template_directory_uri());
define('THEME_PATH', get_template_directory());
define('SITE_URL', get_site_url());


// Remove generator meta tag
remove_action('wp_head', 'wp_generator');

include_once 'inc/css.php';
include_once 'inc/js.php';



add_action( 'after_setup_theme', 'murcutt_setup' );
if ( ! function_exists( 'murcutt_setup' ) ):
function murcutt_setup() {
	global $wp_roles;
	load_theme_textdomain( 'murcutt', get_template_directory() . '/languages' );
	// This theme styles the visual editor with editor-style.pps to match the theme style.
	add_editor_style();

	// This theme uses wp_nav_menu() in one location.
	register_nav_menu( 'primary', __( 'Primary Menu', 'murcutt' ) );

	// This theme uses Featured Images (also known as post thumbnails) for per-post/per-page Custom Header images
	add_theme_support( 'post-thumbnails' );
	
	add_image_size('list_thumb',600,99999);	
	add_image_size('list_portfolio',600,400,true);	
	// add_image_size('realisaties',800,99999);
	// add_image_size('gallery_detail',800,99999);
	// add_image_size('list_blog',470,313,true);
	// add_image_size('related_blog',240,160,true);
 
	register_sidebar(array(
		'name' => __('Sidebar 1'),
		'id' => 'sidebar',
		'description' => __( 'Widgets in this area will be shown on the right-hand side of the page.' ),
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => "</div>",
		'before_title' => '<h3>',
		'after_title' => '</h3>'
	));

	register_sidebar(array(
		'name' => __('Sidebar 2'),
		'id' => 'sidebar2',
		'description' => __( 'Widgets in this area will be shown on the right-hand side of the page.' ),
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => "</div>",
		'before_title' => '<h3>',
		'after_title' => '</h3>'
	));
}
endif; // murcutt_setup


function custom_excerpt_length( $length ) {
	return 45;
}
add_filter( 'excerpt_length', 'custom_excerpt_length', 999 );


function new_excerpt_more($more) {
	global $post;
	return '...';
}
add_filter('excerpt_more', 'new_excerpt_more');

// Include all widget files
foreach (glob(get_template_directory() . '/widget/*.php') as $filename) {
	include_once $filename;
}

function murcutt_comment($comment, $args, $depth) {
	$GLOBALS['comment'] = $comment; ?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
		<div id="comment-<?php comment_ID(); ?>" class="comment-node">
		<?php if ($comment->comment_approved == '0') : ?>
			<em><?php _e('Your comment is awaiting moderation.') ?></em>
			<br />
		<?php endif; ?>

		<?php comment_text() ?>

		<div class="comment-author vcard">
			<?php printf(__('From <cite class="fn">%s</cite> '), get_comment_author_link()) ?> 
			on <?php echo get_comment_date('d/m/Y'); ?>
		</div>
	</div>
<?php
}


function add_slug_body_class( $classes ) {
global $post;
if ( isset( $post ) ) {
	$classes[] = $post->post_type . '-' . $post->post_name;
}
	return $classes;
}
add_filter( 'body_class', 'add_slug_body_class' );



